# Generated by Django 2.2.11 on 2021-10-26 16:25

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('report_designer', '0005_auto_20211026_1805'),
    ]

    operations = [
        migrations.CreateModel(
            name='Report',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200, unique=True, verbose_name='Наименование')),
                ('updated', models.DateTimeField(auto_now=True, verbose_name='Дата и время обновления')),
                ('is_visible_in_reports', models.BooleanField(default=True, verbose_name='Отображать в перечне отчетов при формировании нового отчета')),
                ('author', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='rd_reports', to=settings.AUTH_USER_MODEL, verbose_name='Автор')),
            ],
            options={
                'verbose_name': 'Отчет',
                'verbose_name_plural': 'Отчеты',
                'ordering': ('-pk',),
            },
        ),
        migrations.CreateModel(
            name='ReportField',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200, verbose_name='Наименование')),
                ('alias', models.CharField(blank=True, max_length=200, verbose_name='Псевдоним')),
                ('expression', models.CharField(blank=True, max_length=2000, verbose_name='Выражение')),
                ('internal_type', models.SmallIntegerField(blank=True, choices=[(0, 'Автоинкрементное'), (1, 'Автоинкрементное (64-битное)'), (2, 'Бинарное'), (3, 'Логическое'), (4, 'Строковое'), (5, 'Дата'), (6, 'Дата и время'), (7, 'Десятичное с фиксированной точностью'), (8, 'Период времени (в микросекундах)'), (9, 'Файл'), (10, 'Изображение'), (11, 'Путь до файла'), (12, 'Число с плавающей точкой'), (13, 'Целочисленное'), (14, 'Целочисленное (64-битное)'), (15, 'IP адрес'), (16, 'Логическое с нулевым значением'), (17, 'Положительное целочисленное'), (18, 'Положительное целочисленное (16-битное)'), (19, 'Название-метка'), (20, 'Целочисленное (16-битное)'), (21, 'Текстовое'), (22, 'Время'), (23, 'URL'), (24, 'UUID')], null=True, verbose_name='Тип поля')),
                ('order', models.PositiveSmallIntegerField(default=0, verbose_name='Порядковый номер')),
                ('is_virtual', models.BooleanField(default=False, verbose_name='Виртуальное поле')),
                ('is_group', models.BooleanField(default=False, verbose_name='Групповое поле')),
                ('is_sort', models.BooleanField(default=False, verbose_name='Сортировочное поле')),
                ('reverse_sort', models.BooleanField(default=False, verbose_name='Обратная сортировка')),
                ('is_aggregate', models.BooleanField(default=False, help_text='Аггрегация производится для групповых полей отчета', verbose_name='Агрегированное поле')),
                ('aggregate_function', models.CharField(blank=True, choices=[('sum', 'Сумма'), ('mean', 'Среднее'), ('max', 'Максимальное'), ('min', 'Минимальное')], max_length=20, null=True, verbose_name='Функция агрегирования')),
                ('field', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='report_fields', to='report_designer.TableField', verbose_name='Поле таблицы БД')),
            ],
            options={
                'verbose_name': 'Поле отчета',
                'verbose_name_plural': 'Поля отчетов',
                'ordering': ('order', '-pk'),
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ReportFieldRelation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('order', models.PositiveSmallIntegerField(default=0, verbose_name='Порядок поле в связи')),
                ('report_field', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='report_designer.ReportField', verbose_name='Поле отчета')),
                ('table_field', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='report_designer.TableField', verbose_name='Поле таблицы')),
            ],
            options={
                'verbose_name': 'Связь поля отчета',
                'verbose_name_plural': 'Связи полей очтетов',
                'ordering': ('order',),
                'unique_together': {('order', 'report_field', 'table_field')},
            },
        ),
        migrations.CreateModel(
            name='ReportGroup',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200, unique=True, verbose_name='Наименование')),
            ],
            options={
                'verbose_name': 'Группа отчета',
                'verbose_name_plural': 'Группы отчетов',
                'ordering': ('-pk',),
            },
        ),
        migrations.RemoveField(
            model_name='patternfield',
            name='field',
        ),
        migrations.RemoveField(
            model_name='patternfield',
            name='pattern',
        ),
        migrations.RemoveField(
            model_name='patternfield',
            name='relations',
        ),
        migrations.RemoveField(
            model_name='patternfield',
            name='representation',
        ),
        migrations.AlterUniqueTogether(
            name='patternfieldrelation',
            unique_together=None,
        ),
        migrations.RemoveField(
            model_name='patternfieldrelation',
            name='pattern_field',
        ),
        migrations.RemoveField(
            model_name='patternfieldrelation',
            name='table_field',
        ),
        migrations.DeleteModel(
            name='Pattern',
        ),
        migrations.DeleteModel(
            name='PatternField',
        ),
        migrations.DeleteModel(
            name='PatternFieldRelation',
        ),
        migrations.DeleteModel(
            name='PatternGroup',
        ),
        migrations.AddField(
            model_name='reportfield',
            name='relations',
            field=models.ManyToManyField(blank=True, related_name='relations_report_fields', through='report_designer.ReportFieldRelation', to='report_designer.TableField', verbose_name='Связь с корневой таблицей'),
        ),
        migrations.AddField(
            model_name='reportfield',
            name='report',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='report_fields', to='report_designer.Report', verbose_name='Отчет'),
        ),
        migrations.AddField(
            model_name='reportfield',
            name='representation',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='reportfield_fields', to='report_designer.Format', verbose_name='Представление'),
        ),
        migrations.AddField(
            model_name='report',
            name='groups',
            field=models.ManyToManyField(blank=True, related_name='reports', to='report_designer.ReportGroup', verbose_name='Группы отчетов'),
        ),
        migrations.AddField(
            model_name='report',
            name='root',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='root_table_reports', to='report_designer.DBTable', verbose_name='Основная таблица'),
        ),
        migrations.AddField(
            model_name='report',
            name='tables',
            field=models.ManyToManyField(related_name='reports', to='report_designer.DBTable', verbose_name='Таблицы БД'),
        ),
    ]
