# Generated by Django 2.2.11 on 2021-10-27 14:34

from django.db import migrations, models
import django.db.models.deletion
import mptt.fields


class Migration(migrations.Migration):

    dependencies = [
        ('report_designer', '0008_remove_report_tables'),
    ]

    operations = [
        migrations.CreateModel(
            name='ReportTableRelation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200, verbose_name='Наименование')),
                ('lft', models.PositiveIntegerField(editable=False)),
                ('rght', models.PositiveIntegerField(editable=False)),
                ('tree_id', models.PositiveIntegerField(db_index=True, editable=False)),
                ('level', models.PositiveIntegerField(editable=False)),
                ('parent', mptt.fields.TreeForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='children', to='report_designer.ReportTableRelation', verbose_name='Родительская связь')),
                ('report_table', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='relations', to='report_designer.ReportTable', verbose_name='Таблица отчета')),
            ],
            options={
                'verbose_name': 'Связь до таблицы отчета',
                'verbose_name_plural': 'Связи до таблиц отчетов',
                'ordering': ('-pk',),
            },
        ),
        migrations.CreateModel(
            name='ReportTableRelationCondition',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('order', models.PositiveSmallIntegerField(default=0, verbose_name='Порядковый номер')),
                ('from_field', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='report_table_rel_from', to='report_designer.TableField', verbose_name='Начальное поле')),
                ('report_table_relation', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='from_report_table_relations', to='report_designer.ReportTableRelation', verbose_name='Связь до таблицы отчета')),
                ('to_field', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='report_table_rel_to', to='report_designer.TableField', verbose_name='Конечное поле')),
            ],
            options={
                'verbose_name': 'Условие связи таблицы отчета',
                'verbose_name_plural': 'Условия связи таблиц отчетов',
                'ordering': ('order', '-pk'),
            },
        ),
    ]
